`ifndef CYCLES
 `define CYCLES 10000
`endif

module tm;

   reg resn= 0;
   reg clk= 0;
   reg clk1m= 0;
   //reg btn= 0;

   reg [31:0] addr= 0;
   reg 	      write_en= 0;
   reg 	      read_en= 0;
   reg [3:0]  byte_strobe= 0;
   reg [31:0] wdata= 0;
   wire [31:0] rdata;
   reg [63:0] cnt= 0;
   reg	      rotup= 1;
   
   always #1 clk<= ~clk;
   always /*@(posedge clk)*/#4 clk1m<= ~clk1m;

   wire       bt;
   wire       rx;
   reg [9:0]  du= 10'b0010101011;
   reg [3:0]  du_cnt= 0;

   wire [31:0] PA;
   wire [31:0] PB;
   wire [31:0] PC;
   wire [31:0] PD;
   reg [31:0]  PIr= 0;
   reg [31:0]  PJr= 0;
   
   wire	       rota, rotb;
   incenc
     #(
       .PRE(100)
       )
   rotenc
     (
      .clk(clk1m),
      .en(1'b1),
      .up(rotup),
      .a(rota),
      .b(rotb)
      );

   wire [31:0] PI;
   //assign PI= {PIr[31:2],rotb,rota};
   assign PI= PIr;
   wire [31:0] PJ= PJr;
   comp test_computer
     (
      .CLK	(clk),
      .RESETn	(resn),
      .BOOT_MODE(1'b0/*btn*/),
      .PA_P0    (PA),
      .PB_P0    (PB),
      .PC_P0    (PC),
      .PD_P0    (PD),
      .PI_P0    (PI),
      .PJ_P0    (PJ),
      .CLK_1M   (clk1m),
      .BAUDTICK_P0(bt)//,
      //.RXD_P0   (rx)
      );
   
   always @(posedge bt)
     begin
	if (du_cnt==9)
	  du_cnt<=0;
	else
	  du_cnt<=du_cnt+1;
     end
   assign rx= du[du_cnt];

   initial
     begin
	//PJr= 50;
	//PIr= 1;
	PIr[2:0]= 3'd3;
	PIr[5:3]= 3'd5;
	PJr[2:0]= 3'd1;
	PJr[5:3]= 3'd7;
	//#2000 PJr= 10;
     end
   
   initial
     begin
	$dumpfile("tm.vcd");
	$dumpvars(0,PA,PB,PC,PD,PI,PJ,PIr,PJr);
	//$dumpvars();
	#13 resn= 1;
	#(2*`CYCLES) $finish();
     end
   
endmodule // tm
